您的位置:首页 > 其它

Codeforces Round #293 (Div. 2) -- D. Ilya and Escalator(概率DP)

2016-07-07 10:18 453 查看
[align=center]D. Ilya and Escalator[/align]

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

Ilya got tired of sports programming, left university and got a job in the subway. He was given the task to determine the escalator load factor.

Let's assume that n people stand in the queue for the escalator. At each second one of the two following possibilities takes place: either the first person in the queue enters the escalator with probability
p, or the first person in the queue doesn't move with probability
(1 - p), paralyzed by his fear of escalators and making the whole queue wait behind him.

Formally speaking, the i-th person in the queue cannot enter the escalator until people with indices from
1 to i - 1 inclusive enter it. In one second only one person can enter the escalator. The escalator is infinite, so if a person enters it, he never leaves it, that is he will be standing on
the escalator at any following second. Ilya needs to count the expected value of the number of people standing on the escalator after
t seconds.

Your task is to help him solve this complicated task.

Input
The first line of the input contains three numbers n, p, t (1 ≤ n, t ≤ 2000,
0 ≤ p ≤ 1). Numbers
n and t are integers, number
p is real, given with exactly two digits after the decimal point.

Output
Print a single real number — the expected number of people who will be standing on the escalator after
t seconds. The absolute or relative error mustn't exceed
10 - 6.

Examples

Input
1 0.50 1


Output
0.5


Input
1 0.50 4


Output
0.9375


Input
4 0.20 2


Output
0.4
大体题意:
有n 个人排队做电梯,队首的人 进电梯的概率为p  不进的概率为 1-p,且1秒只能进一个人,问t秒后,电梯中人数
的期望值。

思路:
概率dp,令dp[i][j] 表示第i秒时 j 个人的概率!
①那么当j == n时,一部分概率来自i-1秒 j-1个人时  在进来一个人 。另一部分来自i-1秒时已经有n 个人了,队列
中没人了!所以不用再乘概率1-p。
所以dp[i][j] = dp[i-1][j-1] * p + dp[i-1][j];
②当j == 0时,概率只可能来自  i-1秒时不进来人。
dp[i][j] = dp[i-1][j] * (1-p);
③当0 < j < n时,一部分概率可以来自i-1秒 j-1个人 在进来一个人,另一部分来自i-1秒时已经有j个人了,队列
中还有人,所以要乘以不进来的概率(1-p)。
dp[i][j] = dp[i-1][j] * (1-p) + dp[i-1][j-1] * p;
最后算一下期望即可!
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
const int maxn = 2000 + 10;

double dp[maxn][maxn];
int main(){
int n,t;
double p;
while(scanf("%d %lf %d",&n,&p,&t ) == 3){
memset(dp,0,sizeof dp);
dp[0][0] = 1.0;
for (int i = 1; i <= t; ++i){
for (int j = 0; j <= n; ++j){
if (j == n){
dp[i][j] = dp[i-1][j-1] * p + dp[i-1][j];
}
else if (j > 0)
dp[i][j] = dp[i-1][j]*(1-p) + dp[i-1][j-1] * p;
else if (j == 0)
dp[i][j] = dp[i-1][j] * (1-p);
}
}
double ans = 0;
for (int i = 1; i <= n; ++i){
ans += dp[t][i] * i;
}
printf("%.10lf\n",ans);

}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: